"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var React = require("react");
var Input_1 = require("../Input");
exports.startOfDay = function (val) { return moment(val).startOf('day'); };
exports.rules = {
    is: function (target, value) { return target && exports.startOfDay(target).isSame(exports.startOfDay(value)); },
    'is before': function (target, value) {
        return target && exports.startOfDay(target).isBefore(exports.startOfDay(value));
    },
    'is after': function (target, value) {
        return target && exports.startOfDay(target).isAfter(exports.startOfDay(value));
    }
};
exports.validate = function (value) { return moment(value).isValid(); };
exports.normalize = function (value) { return value; };
exports.Edit = function (_a) {
    var value = _a.value, onChange = _a.onChange, props = __rest(_a, ["value", "onChange"]);
    return (React.createElement(Input_1.default, __assign({}, props, { type: 'date', value: value, onChange: function (e) { return onChange(e.target.value); } })));
};
exports.Display = function (_a) {
    var data = _a.data, _b = _a.dateFormat, dateFormat = _b === void 0 ? 'dddd, MMMM Do YYYY' : _b, props = __rest(_a, ["data", "dateFormat"]);
    return (React.createElement("div", __assign({}, props),
        React.createElement("span", null, moment(data).format(dateFormat))));
};
